---
schema_version: "1"
id: 9aa46e0480dcba7d31090e2d4e104607060e3492657cca8c8ef81b28aeaf4c0e
title: Salesforce Commerce Cart API
collection: developer
version: current
locale: en-us
portal_url: https://docs.salesforce.com/developer/current/en-us/commerce-cloud/salesforce-commerce/references/generated-api-specs/comm-cart-ref.md
canonical_url: https://developer.salesforce.com/docs/commerce/salesforce-commerce/references/comm-cart-ref
source_site: developer.salesforce.com
content_type: documentation
content_hash: 003154e846e7d986899802a8709f8c02e35b4c89a9ffe989088d5a9c4a6cd3c0
products:
  - B2B Commerce Developer Guide
  - Salesforce APIs
---
Salesforce Commerce Cart API

# Salesforce Commerce Cart API

Salesforce Commerce Cart Connect APIs enable developers to effortlessly perform various tasks, including creating, updating, and managing carts. Key functionalities encompass adding or removing items, adjusting quantities, transferring items to wishlists, applying promotions, using coupons, and splitting a cart into multiple delivery groups.

**Note:** The Salesforce Commerce Cart APIs aren’t supported in preview mode.

**Version:** 67.0

## Servers

*   `https://{yourinstance}.salesforce.com/services/data/{version}`
    *   `version (default v67.0)`

## Operations

### POST Set the visibility for cart messages.

`POST /commerce/webstores/{webstoreId}/carts/{activeCartOrId}/messages/actions/set-visibility`

Operation ID: `postCartMessagesVisibility`.

Updates the visibility for cart level messages associated a single WebCart.

The visibility settings for cart messages enable real-time updates and notifications, ensuring customers stay informed about changes to their carts, such as item availability, price adjustments, or promotional offers.

#### Parameters

*   `activeCartOrId` (path, string, required) The valid value is—cartId (ID of the cart), active (this value is only to be used for authenticated users), or current (cart that isn’t closed or pending deletion). Use active only for B2B Aura stores; all other stores must use current.
*   `webstoreId` (path, string (Id), required) The ID of the web store.
*   `effectiveAccountId` (query, string (Id)) The ID of the buyer account or guest buyer profile for which the request is made. If unspecified, the default value is determined from context.

#### Request body

Media type: `application/json`. Schema: `sfdc.commerce.cart.connect.api.input.CartMessagesVisibilityInputRepresentation`.

_Example: Example_ Set the visibility for cart messages.

```
{
  "visibility": true
}
```

#### Responses

*   **200** Success
    
    Media type: `application/json`. Schema: `sfdc.commerce.cart.connect.api.output.CartMessagesVisibilityResultRepresentation`.
    

### POST Add a batch of up to 100 items to a cart.

`POST /commerce/webstores/{webstoreId}/carts/{activeCartOrId}/cart-items/batch`

Operation ID: `postCartItemBatchCollection`.

Allows batch adding of cart items.

Buyers with read access to carts can add items to carts. Adding items to a cart respects the buyer's view product entitlements, and only users entitled to view product data can access it.

**Note:** The `postCartItemBatchCollection` resource doesn't support dynamic bundles or dynamic attributes for configurable products. To apply or update configurations for these bundles, use the [`postCartItemsFromConfiguration`](https://developer.salesforce.com/docs/commerce/salesforce-commerce/references/comm-cart-ref?meta=postCartItemsFromConfiguration) resource instead.

#### Parameters

*   `activeCartOrId` (path, string, required) The valid value is—cartId (ID of the cart), active (this value is only to be used for authenticated users), or current (cart that isn’t closed or pending deletion). Use active only for B2B Aura stores; all other stores must use current.
*   `webstoreId` (path, string (Id), required) The ID of the web store.
*   `currencyIsoCode` (query, string) The three-letter ISO 4217 currency code of the cart.
*   `effectiveAccountId` (query, string (Id)) The ID of the buyer account or guest buyer profile for which the request is made. If unspecified, the default value is determined from context.

#### Request body

Media type: `application/json`. Schema: `object`.

*   `inputs` (_array of object_)
    *   `richInput` (_sfdc.commerce.cart.connect.api.input.CartItemInputRepresentation_)

_Example: RichInput_ Rich input example

```
{
  "inputs": [
    {
      "richInput": {
        "quantity": 2,
        "productId": "01txx0000006i2SAAQ",
        "type": "Product"
      }
    },
    {
      "richInput": {
        "quantity": 15,
        "productId": "01txx0000006i3AAAQ",
        "type": "Product"
      }
    }
  ]
}
```

_Example: BinaryPartInput_ Binary part input example

```
{
  "inputs": [
    {
      "binaryPartNames": "bin1",
      "richInput": {
        "subjectId": "me",
        "body": {
          "messageSegments": [
            {
              "type": "Text",
              "text": "Please accept this receipt"
            }
          ]
        },
        "capabilities": {
          "content": {
            "description": "Receipt for expenses",
            "title": "receipt.pdf"
          }
        },
        "feedElementType": "FeedItem"
      }
    }
  ]
}
```

#### Responses

*   **200** Success
    
    Media type: `application/json`. Schema: `core.connect.api.output.common.BatchRepresentation`.
    
    _Example: Example_ Example of the successful cart items creation response.
    
    ```
    {
      "hasErrors": false,
      "results": [
        {
          "statusCode": 201,
          "result": {
            "billingFrequency": null,
            "cartData": null,
            "cartDeliveryGroupId": "0a7xx000000023RAAQ",
            "cartId": "0a6xx000000023RAAQ",
            "cartItemId": "0a9xx00000003ifAAA",
            "childProductCount": 0,
            "currencyIsoCode": "USD",
            "customFields": [],
            "firstPymtTotalAmount": null,
            "firstPymtTotalListPrice": "49.98",
            "firstPymtTotalPrice": "41.00",
            "firstPymtTotalTax": null,
            "isConfigurationAllowed": false,
            "isShippingChargeNotApplicable": false,
            "itemizedAdjustmentAmount": "0.00",
            "listPrice": "24.99",
            "messagesSummary": {
              "errorCount": null,
              "hasErrors": null,
              "limitedMessages": [],
              "relatedEntityId": null,
              "totalLineItemsWithErrors": null
            },
            "name": "Alpine Energy Drink Chai Post 0.5L PET - 6 pack",
            "parentCartItemId": null,
            "productClass": "Simple",
            "productDetails": {
              "dynamicAttributes": {},
              "fields": {},
              "isConfigurationAllowed": null,
              "name": "Alpine Energy Drink Chai Post 0.5L PET - 6 pack",
              "productClass": null,
              "productId": "01txx0000006i2SAAQ",
              "productSubscriptionInformation": null,
              "productUrlName": null,
              "purchaseQuantityRule": null,
              "sku": "6010009",
              "thumbnailImage": null,
              "variationAttributes": {}
            },
            "productId": "01txx0000006i2SAAQ",
            "productSellingModelId": null,
            "promotionDisplayName": null,
            "quantity": "2",
            "quoteLineItemId": null,
            "salesPrice": "20.50",
            "sellingModelType": null,
            "subType": null,
            "subscriptionTerm": null,
            "totalAdjustmentAmount": "0.00",
            "totalAmount": null,
            "totalListPrice": "49.98",
            "totalPrice": "41.00",
            "totalTax": null,
            "type": "Product",
            "unitAdjustedPrice": "20.50",
            "unitAdjustedPriceWithItemAdj": "20.50",
            "unitAdjustmentAmount": "0",
            "unitItemAdjustmentAmount": "0.00"
          }
        }
      ]
    }
    ```
    

### POST Evaluate the shipping costs for a cart.

`POST /commerce/webstores/{webstoreId}/carts/{activeCartOrId}/actions/evaluate-shipping`

Operation ID: `postCartEvaluateShipping`.

Evaluates the shipping costs for an existing cart.

#### Parameters

*   `activeCartOrId` (path, string, required) The valid value is—cartId (ID of the cart), active (this value is only to be used for authenticated users), or current (cart that isn’t closed or pending deletion). Use active only for B2B Aura stores; all other stores must use current.
*   `webstoreId` (path, string (Id), required) The ID of the web store.
*   `effectiveAccountId` (query, string (Id)) Optional. The ID of the account for which the request is made. If unspecified, defaults to the account ID for the context user.

#### Request body

Media type: `application/json`. Schema: `sfdc.commerce.cart.connect.api.input.CartEvaluateShippingInputRepresentation`.

_Example: CartEvaluateShippingInput_ Example of the cart evaluate shipping input.

```
{
  "customFields": [
    {
      "attributes": {
        "type": "WebCart"
      },
      "WebCartCustomField1__c": "Foo"
    },
    {
      "attributes": {
        "type": "CartItem"
      },
      "id": "0a9xx0000000002CI1",
      "CartItemCustomField1__c": "CI1_Field1Value",
      "CartItemCustomField2__c": "CI1_Field2Value"
    },
    {
      "attributes": {
        "type": "CartItem"
      },
      "id": "0a9xx0000000002CI2",
      "CartItemCustomField1__c": "CI2_Field1Value",
      "CartItemCustomField2__c": "CI2_Field2Value"
    },
    {
      "attributes": {
        "type": "CartDeliveryGroup"
      },
      "id": "0a7xx000000000CDG1",
      "CartDeliveryGroupCustomField1__c": "CDG1_Field1Value",
      "CartDeliveryGroupCustomField2__c": "CDG1_Field2Value"
    }
  ],
  "shippingAddress": {
    "name": "Alan Johnson",
    "firstName": "Alan",
    "id": "0a6xx0000000000",
    "lastName": "Johnson",
    "region": "CA",
    "country": "US",
    "city": "San Francisco",
    "street": "415 Mission St",
    "postalCode": 94105
  }
}
```

#### Responses

*   **200** Success
    
    Media type: `application/json`. Schema: `sfdc.commerce.cart.connect.api.output.CartSummaryResultRepresentation`.
    

### GET Retrieve cart items of a specific product.

`GET /commerce/webstores/{webstoreId}/carts/{activeCartOrId}/products/{productId}`

Operation ID: `getProductCartItem`.

A collection of cartitems for a given product in the cart.

#### Parameters

*   `activeCartOrId` (path, string, required) The valid value is—cartId (ID of the cart), active (this value is only to be used for authenticated users), or current (cart that isn’t closed or pending deletion). Use active only for B2B Aura stores; all other stores must use current.
*   `productId` (path, string (Id), required) The ID of the product.
*   `webstoreId` (path, string (Id), required) The ID of the web store.
*   `currencyIsoCode` (query, string) The three-letter ISO 4217 currency code of the cart.
*   `effectiveAccountId` (query, string (Id)) The ID of the buyer account or guest buyer profile for which the request is made. If unspecified, the default value is determined from context.
*   `productFields` (query, string) The comma-separated list of up to 15 product fields. Results include fields that you have access to. Some product fields (such as productName and sku) are returned even when not included in the productFields parameter.

#### Responses

*   **200** Success
    
    Media type: `application/json`. Schema: `sfdc.commerce.cart.connect.api.output.ProductCartItemRepresentation`.
    

### PUT Create and update an inventory reservation from the cart.

`PUT /commerce/webstores/{webstoreId}/carts/{activeCartOrId}/inventory-reservations`

Operation ID: `putCartInventoryReservation`.

Handle Inventory Reservations.

#### Parameters

*   `activeCartOrId` (path, string, required) The valid value is—cartId (ID of the cart), active (this value is only to be used for authenticated users), or current (cart that isn’t closed or pending deletion). Use active only for B2B Aura stores; all other stores must use current.
*   `webstoreId` (path, string (Id), required) The ID of the web store.
*   `effectiveAccountId` (query, string (Id)) The ID of the buyer account or guest buyer profile for which the request is made. If unspecified, the default value is determined from context.

#### Request body

Media type: `application/json`. Schema: `sfdc.commerce.cart.connect.api.input.CartInventoryReservationInputRepresentation`.

_Example: Example_ Example of the cart inventory reservation input.

```
{
  "durationInSeconds": 100
}
```

#### Responses

*   **200** Success
    
    Media type: `application/json`. Schema: `sfdc.commerce.cart.connect.api.output.CartInventoryReservationOutputRepresentation`.
    
    _Example: Example_ Example of the cart inventory reservation response.
    
    ```
    {
      "errorCode": null,
      "errorMessage": "Success",
      "inventoryItemReservations": [
        {
          "errorCode": null,
          "errorMessage": "Success",
          "id": "2pmSG000005k7q3YAA",
          "itemReservationSourceId": null,
          "productId": "01tSG000003uisiYAA",
          "quantity": 3,
          "reservedAtLocationId": null
        }
      ],
      "reservationIdentifier": null,
      "success": true
    }
    ```
    
*   **400** Bad Request
    
    Media type: `application/json`. Schema: `sfdc.commerce.cart.connect.api.output.CartInventoryReservationOutputRepresentation`.
    
    _Example: Example_ Client error.
    
    ```
    [
      {
        "errorCode": "JSON_PARSER_ERROR",
        "message": "Unexpected character. Expected a valid value."
      }
    ]
    ```
    

### DELETE Delete an inventory reservation from the cart.

`DELETE /commerce/webstores/{webstoreId}/carts/{activeCartOrId}/inventory-reservations`

Operation ID: `deleteCartInventoryReservation`.

Handle Inventory Reservations.

#### Parameters

*   `activeCartOrId` (path, string, required) The valid value is—cartId (ID of the cart), active (this value is only to be used for authenticated users), or current (cart that isn’t closed or pending deletion). Use active only for B2B Aura stores; all other stores must use current.
*   `webstoreId` (path, string (Id), required) The ID of the web store.
*   `effectiveAccountId` (query, string (Id)) The ID of the buyer account or guest buyer profile for which the request is made. If unspecified, the default value is determined from context.

#### Responses

*   **200** Success

### GET Retrieve the items in a cart, sorted by product ID.

`GET /commerce/webstores/{webstoreId}/carts/{activeCartOrId}/products`

Operation ID: `getProductCartItemCollection`.

A collection of items grouped by product in the cart.

#### Parameters

*   `activeCartOrId` (path, string, required) The valid value is—cartId (ID of the cart), active (this value is only to be used for authenticated users), or current (cart that isn’t closed or pending deletion). Use active only for B2B Aura stores; all other stores must use current.
*   `webstoreId` (path, string (Id), required) The ID of the web store.
*   `currencyIsoCode` (query, string) The three-letter ISO 4217 currency code of the cart.
*   `effectiveAccountId` (query, string (Id)) The ID of the buyer account or guest buyer profile for which the request is made. If unspecified, the default value is determined from context.
*   `pageNumber` (query, integer) Specifies the requested page number.
*   `pageSize` (query, integer) Specifies the number of items per page. Valid values are from 1 through 100. If you don’t specify a value, the default size is 25.
*   `productFields` (query, string) The comma-separated list of up to 15 product fields. Results include fields that you have access to. Some product fields (such as productName and sku) are returned even when not included in the productFields parameter.

#### Responses

*   **200** Success
    
    Media type: `application/json`. Schema: `sfdc.commerce.cart.connect.api.output.ProductCartItemCollectionRepresentation`.
    
*   **400** Bad Request
    
    Media type: `application/json`. Schema: `sfdc.commerce.cart.connect.api.output.ProductCartItemCollectionRepresentation`.
    
    _Example: Example_ Example of 400 Bad Requests
    
    ```
    [
      {
        "errorCode": "ILLEGAL_QUERY_PARAMETER_VALUE",
        "message": "You must log in to browse our store."
      }
    ]
    ```
    

### POST Copy the products from a cart to a wishlist.

`POST /commerce/webstores/{webstoreId}/carts/{activeCartOrId}/actions/add-cart-to-wishlist`

Operation ID: `postCartToWishlist`.

Used to copy products from Cart to Wishlist.

#### Parameters

*   `activeCartOrId` (path, string, required) The valid value is—cartId (ID of the cart), active (this value is only to be used for authenticated users), or current (cart that isn’t closed or pending deletion). Use active only for B2B Aura stores; all other stores must use current.
*   `webstoreId` (path, string (Id), required) The ID of the web store.
*   `effectiveAccountId` (query, string (Id)) The ID of the buyer account or guest buyer profile for which the request is made. If unspecified, the default value is determined from context.

#### Request body

Media type: `application/json`. Schema: `sfdc.commerce.cart.connect.api.input.CartToWishlistInputRepresentation`.

_Example: Example_ Successfully added cart items to wishlist.

```
{
  "wishlistId": "3orxx00000000A1"
}
```

#### Responses

*   **200** Success
    
    Media type: `application/json`. Schema: `sfdc.commerce.cart.connect.api.output.CartToWishlistResultRepresentation`.
    
    _Example: Example_ Successfully moved cart items to a wishlist.
    
    ```
    {
      "productsAddedCount": 10,
      "wishlistId": "3orxx00000000A1"
    }
    ```
    

### POST Clone an existing cart to create a secondary.

`POST /commerce/webstores/{webstoreId}/carts/{activeCartOrId}/actions/clone`

Operation ID: `postCartClone`.

Clones an existing cart to create a secondary, read-only cart to support Pay Now functionality. Sets the guest cart status to PendingDelete in a B2B store or Closed in a D2C store.

This creates a secondary, read-only cart to support Pay Now functionality. Sets the guest cart status to PendingDelete in a B2B store or Closed in a D2C store.

#### Parameters

*   `activeCartOrId` (path, string, required) The valid value is—cartId (ID of the cart), active (this value is only to be used for authenticated users), or current (cart that isn’t closed or pending deletion). Use active only for B2B Aura stores; all other stores must use current.
*   `webstoreId` (path, string (Id), required) The ID of the web store.
*   `targetEffectiveAccountId` (query, string (Id)) The effective account ID associated with the cloned cart.
*   `targetType` (query, string) The type of the cloned cart. Value is PayNowReadOnly.

#### Responses

*   **200** Success
    
    Media type: `application/json`. Schema: `sfdc.commerce.cart.connect.api.output.CartSummaryRepresentation`.
    

### POST Make a secondary cart a primary cart.

`POST /commerce/webstores/{webstoreId}/carts/{activeCartOrId}/actions/make-primary`

Operation ID: `postCartMakePrimary`.

Makes a secondary cart a primary cart.

#### Parameters

*   `activeCartOrId` (path, string, required) The valid value is—cartId (ID of the cart), active (this value is only to be used for authenticated users), or current (cart that isn’t closed or pending deletion). Use active only for B2B Aura stores; all other stores must use current.
*   `webstoreId` (path, string (Id), required)
*   `effectiveAccountId` (query, string (Id)) The ID of the buyer account or guest buyer profile for which the request is made. If unspecified, the default value is determined from context.

#### Responses

*   **200** Success
    
    Media type: `application/json`. Schema: `sfdc.commerce.cart.connect.api.output.CommerceActionResultRepresentation`.
    

### DELETE Delete a coupon from a cart.

`DELETE /commerce/webstores/{webstoreId}/carts/{activeCartOrId}/cart-coupons/{cartCouponId}`

Operation ID: `deleteCartCoupon`.

Used to delete single cart coupon.

If your store has simplified cart cleanup enabled, a DELETE request can remove a coupon from a cart without canceling checkout.

#### Parameters

*   `activeCartOrId` (path, string, required) The valid value is—cartId (ID of the cart), active (this value is only to be used for authenticated users), or current (cart that isn’t closed or pending deletion). Use active only for B2B Aura stores; all other stores must use current.
*   `cartCouponId` (path, string (Id), required) The ID of the cart coupon code.
*   `webstoreId` (path, string (Id), required) The ID of the web store.
*   `currencyIsoCode` (query, string) The three-letter ISO 4217 currency code of the cart.
*   `effectiveAccountId` (query, string (Id)) The ID of the buyer account or guest buyer profile for which the request is made. If unspecified, the default value is determined from context.

#### Responses

*   **200** Success

### POST Evaluate taxes for a cart.

`POST /commerce/webstores/{webstoreId}/carts/{activeCartOrId}/actions/evaluate-taxes`

Operation ID: `postCartEvaluateTax`.

Evaluates taxes for an existing cart.

#### Parameters

*   `activeCartOrId` (path, string, required) The valid value is—cartId (ID of the cart), active (this value is only to be used for authenticated users), or current (cart that isn’t closed or pending deletion). Use active only for B2B Aura stores; all other stores must use current.
*   `webstoreId` (path, string (Id), required) The ID of the web store.
*   `effectiveAccountId` (query, string (Id)) The ID of the account for which the request is made. If unspecified, defaults to the account ID for the context user.

#### Request body

Media type: `application/json`. Schema: `sfdc.commerce.cart.connect.api.input.CartEvaluateTaxInputRepresentation`.

_Example CartEvaluateTaxInput: same as POST /commerce/webstores/{webstoreId}/carts/{activeCartOrId}/actions/evaluate-shipping request._ Example of the cart evaluate tax input.

_Example: CartEvaluateTaxInput_ Example of the cart evaluate tax input.

#### Responses

*   **200** Success
    
    Media type: `application/json`. Schema: `sfdc.commerce.cart.connect.api.output.CartSummaryResultRepresentation`.
    

### GET Retrieve the items in a cart.

`GET /commerce/webstores/{webstoreId}/carts/{activeCartOrId}/cart-items`

Operation ID: `getCartItemCollection`.

A collection of items in the cart.

If there isn’t a current cart, it returns an empty cart.

#### Parameters

*   `activeCartOrId` (path, string, required) The valid value is—cartId (ID of the cart), active (this value is only to be used for authenticated users), or current (cart that isn’t closed or pending deletion). Use active only for B2B Aura stores; all other stores must use current.
*   `webstoreId` (path, string (Id), required) The ID of the web store.
*   `currencyIsoCode` (query, string) The three-letter ISO 4217 currency code of the cart.
*   `effectiveAccountId` (query, string (Id)) The ID of the buyer account or guest buyer profile for which the request is made. If unspecified, the default value is determined from context.
*   `includeCoupons` (query, boolean) Indicates whether to include coupons (True) or not (False).
*   `includePromotions` (query, boolean) Indicates whether to include promotions (True) or not (False).
*   `page` (query, string) Specifies the page token to use to view a page of information. Page tokens are returned as part of the response, such as currentPageToken or nextPageToken. If you don’t specify a value, the first page is returned.
*   `pageNumber` (query, integer) Specifies the requested page number.
*   `pageSize` (query, integer) Specifies the number of items per page. Valid values are from 1 through 100. If you don’t specify a value, the default size is 25.
*   `productFields` (query, string) The comma-separated list of up to 15 product fields. Results include fields that you have access to. Some product fields (such as productName and sku) are returned even when not included in the productFields parameter.
*   `sort` (query, sfdc.commerce.cart.connect.api.enums.ConnectCartItemSortOrderEnum)

#### Responses

*   **200** Success
    
    Media type: `application/json`. Schema: `sfdc.commerce.cart.connect.api.output.CartItemCollectionRepresentation`.
    
    _Example: Example_ Example of the fetch cart items response.
    

### POST Add an item to a cart.

`POST /commerce/webstores/{webstoreId}/carts/{activeCartOrId}/cart-items`

Operation ID: `postCartItemCollection`.

A collection of items in the cart.

Buyers with read access to carts can add items in carts. Adding items to a cart respects buyer View Product entitlements and only users entitled to view product data can access it.

#### Parameters

*   `activeCartOrId` (path, string, required) The valid value is—cartId (ID of the cart), active (this value is only to be used for authenticated users), or current (cart that isn’t closed or pending deletion). Use active only for B2B Aura stores; all other stores must use current.
*   `webstoreId` (path, string (Id), required) The ID of the web store.
*   `currencyIsoCode` (query, string) The three-letter ISO 4217 currency code of the cart.
*   `effectiveAccountId` (query, string (Id)) The ID of the buyer account or guest buyer profile for which the request is made. If unspecified, the default value is determined from context.
*   `productFields` (query, string) The comma-separated list of up to 15 product fields. Results include fields that you have access to.
*   `includeCartData` (query, boolean) Specify to include complete cart data in the response. This is available ONLY when in sync mode.

#### Request body

Media type: `application/json`. Schema: `sfdc.commerce.cart.connect.api.input.CartItemInputRepresentation`.

_Example: Example_ Example of the cart item input.

```
{
  "customFields": [
    {
      "attributes": {
        "type": "CartItem"
      },
      "connectCustomLocation__c": {
        "latitude": 3.456,
        "longitude": 7.89
      },
      "connectCustomCurrency__c": 23.4,
      "connectCustomCheckbox__c": true,
      "connectCustomDate__c": "2025-02-17",
      "connectCustomText__c": "sample",
      "connectCustomAddress__c": {
        "city": "city",
        "country": null,
        "geocodeAccuracy": null,
        "latitude": -10,
        "longitude": 1.5,
        "postalCode": "postalCode",
        "state": null,
        "street": "street"
      }
    }
  ],
  "productId": "01t000000000000000",
  "quantity": 5,
  "type": "Product"
}
```

#### Responses

*   **200** Success
    
    Media type: `application/json`. Schema: `sfdc.commerce.cart.connect.api.output.CartItemRepresentation`.
    
    _Example: Example_ Example of the add an item to a cart response.
    
    ```
    {
      "billingFrequency": null,
      "cartData": null,
      "cartDeliveryGroupId": "0a7VW0000001WkDYAU",
      "cartId": "0a6VW0000001WgzYAE",
      "cartItemId": "0a9VW0000002lZ7YAI",
      "childProductCount": 0,
      "currencyIsoCode": "USD",
      "customFields": [
        {
          "attributes": {
            "type": "CartItem"
          },
          "connectCustomLocation__c": {
            "latitude": 3.456
          },
          "longitude": 7.89,
          "connectCustomDate__c": "2025-02-17",
          "connectCustomAddress__c": {
            "city": "city",
            "country": null,
            "geocodeAccuracy": null,
            "latitude": -10,
            "longitude": 1.5,
            "postalCode": "postalCode",
            "state": null,
            "street": "street"
          },
          "connectCustomCurrency__c": 23.4,
          "connectCustomCheckbox__c": true,
          "connectCustomText__c": "sample"
        }
      ],
      "firstPymtTotalAmount": null,
      "firstPymtTotalListPrice": 45,
      "firstPymtTotalPrice": 45,
      "firstPymtTotalTax": null,
      "itemizedAdjustmentAmount": 0,
      "listPrice": 22.5,
      "messagesSummary": {
        "errorCount": null,
        "hasErrors": null,
        "limitedMessages": [],
        "relatedEntityId": null,
        "totalLineItemsWithErrors": null
      },
      "name": "YetiBar Tart Cherry/Bison Paleo 2oz bar",
      "parentCartItemId": null,
      "productClass": "Simple",
      "productDetails": {
        "fields": null,
        "name": "YetiBar Tart Cherry/Bison Paleo 2oz bar",
        "productId": "01tVW000001TP1WYAW",
        "productSubscriptionInformation": null,
        "purchaseQuantityRule": null,
        "sku": 6010056,
        "thumbnailImage": null,
        "variationAttributes": null
      },
      "productId": "01tVW000001TP1WYAW",
      "productSellingModelId": null,
      "quantity": 2,
      "salesPrice": 22.5,
      "sellingModelType": null,
      "subscriptionTerm": null,
      "totalAdjustmentAmount": 0,
      "totalAmount": null,
      "totalListPrice": 45,
      "totalPrice": 45,
      "totalTax": null,
      "type": "Product",
      "unitAdjustedPrice": 22.5,
      "unitAdjustedPriceWithItemAdj": 22.5,
      "unitAdjustmentAmount": 0,
      "unitItemAdjustmentAmount": 0
    }
    ```
    
*   **400** Bad Request
    
    Media type: `application/json`. Schema: `sfdc.commerce.cart.connect.api.output.CartItemRepresentation`.
    
    _Example: Example_ Client error.
    
    ```
    [
      {
        "errorCode": "JSON_PARSER_ERROR",
        "message": "Value doesn't match expected type."
      }
    ]
    ```
    

### GET Retrieves all child items associated with a specified cart item. This API is supported only for product bundles.

`GET /commerce/webstores/{webstoreId}/carts/{activeCartOrId}/cart-items/{cartItemId}/children`

Operation ID: `getChildCartItemCollection`.

Retrieves all child items associated with a specified cart item in the cart. A maximum of 200 child items is allowed per parent cart item.

#### Parameters

*   `cartItemId` (path, string (Id), required) The ID of the parent cart item whose child items you want to retrieve.
*   `activeCartOrId` (path, string, required) The valid value is—cartId (ID of the cart), active (this value is only to be used for authenticated users), or current (cart that isn’t closed or pending deletion). Use active only for B2B Aura stores; all other stores must use current.
*   `webstoreId` (path, string (Id), required) The ID of the web store.
*   `currencyIsoCode` (query, string) The three-letter ISO 4217 currency code of the cart.
*   `effectiveAccountId` (query, string (Id)) The ID of the account for which this request is made. Specify this account ID when the purchase is intended for an account other than the one associated with the current user context. If unspecified, the default value is determined from context.
*   `page` (query, string) Specifies the page token to use to view a page of information. Page tokens are returned as part of the response, such as currentPageToken or nextPageToken. If you don’t specify a value, the first page is returned.
*   `pageSize` (query, integer) Specifies the number of items per page. Valid values are from 1 through 200. The default value is 200.
*   `productFields` (query, string) The comma-separated list of product field names to include in the response. If this list is empty or not specified, a basic set of fields is returned. To include all fields, use '\*'. There is no limit to the number of fields you can specify; however, the total number of fields and the length of field names may impact the URL size limit.
*   `sort` (query, sfdc.commerce.cart.connect.api.enums.ConnectCartItemSortOrderEnum)

#### Responses

*   **200** Success
    
    Media type: `application/json`. Schema: `sfdc.commerce.cart.connect.api.output.ChildCartItemCollectionRepresentation`.
    
    _Example: Example_ Example of the child items associated with a specified cart item.
    
    ```
    {
      "childCartItems": [
        {
          "cartItem": {
            "billingFrequency": null,
            "cartData": null,
            "cartDeliveryGroupId": "0a7xx00000000pdAAA",
            "cartId": "0a6xx00000000pdAAA",
            "cartItemId": "0a9xx00000000zPAAQ",
            "childProductCount": 0,
            "currencyIsoCode": "USD",
            "customFields": [],
            "firstPymtTotalAmount": "20.00",
            "firstPymtTotalListPrice": "30.00",
            "firstPymtTotalPrice": "20.00",
            "firstPymtTotalTax": "0.00",
            "isConfigurationAllowed": false,
            "isShippingChargeNotApplicable": false,
            "itemizedAdjustmentAmount": "0.00",
            "listPrice": "30.0",
            "messagesSummary": {
              "errorCount": null,
              "hasErrors": null,
              "limitedMessages": [],
              "relatedEntityId": null,
              "totalLineItemsWithErrors": null
            },
            "name": "Bag",
            "parentCartItemId": null,
            "productClass": "Simple",
            "productDetails": {
              "fields": {
                "LastModifiedDate": "2025-10-23T11:33:37Z",
                "FulfillmentQtyCalcMethod": null,
                "Description": null,
                "SpecificationType": "Commercial",
                "IsActive": "true",
                "LastReferencedDate": null,
                "StockKeepingUnit": "NHKB",
                "Name": "Bag",
                "ShippingWeightUnitOfMeasure": null,
                "CreatedById": "005xx000001XBov",
                "CloneSourceId": null,
                "RecordTypeId": "012xx0000005qmC",
                "DiscontinuedDate": null,
                "ProductClass": "Simple",
                "CanRamp": "false",
                "DisplayUrl": null,
                "IsDeleted": "false",
                "IsAssetizable": "true",
                "ProductCode": null,
                "UsageModelType": null,
                "ExternalId": null,
                "ProductPurpose": "Sell",
                "LastViewedDate": null,
                "UserRecordAccessId": null,
                "HelpText": null,
                "CurrencyIsoCode": "USD",
                "AvailabilityDate": null,
                "SystemModstamp": "2025-10-23T11:33:37Z",
                "IsArchived": "false",
                "DecompositionScope": null,
                "Type": null,
                "EndOfLifeDate": null,
                "IsShippingChargeNotApplicable": "false",
                "QuantityUnitOfMeasure": null,
                "CreatedDate": "2025-10-23T11:33:37Z",
                "Family": null,
                "UnitOfMeasureId": null,
                "ShippingWeight": null,
                "LastModifiedById": "005xx000001XBov",
                "IsSoldOnlyWithOtherProds": "false"
              },
              "isConfigurationAllowed": null,
              "name": "Bag",
              "productClass": null,
              "productId": "01txx0000006kf1AAA",
              "productSubscriptionInformation": null,
              "productUrlName": null,
              "purchaseQuantityRule": null,
              "sku": "NHKB",
              "thumbnailImage": {
                "alternateText": "bag.jpeg",
                "contentVersionId": null,
                "id": "2pmxx000000000RAAQ",
                "mediaType": "Image",
                "sortOrder": 0,
                "thumbnailUrl": null,
                "title": "bag.jpeg",
                "url": "/cms/delivery/media/MCQMDS7T446NC7XKVP6JOJK2HMSA?version=1.1&channelId=0apxx0000000003&oid=00Dxx00ThLVJ544"
              },
              "variationAttributes": {}
            },
            "productId": "01txx0000006kf1AAA",
            "productSellingModelId": null,
            "promotionDisplayName": null,
            "quantity": "1.0",
            "salesPrice": "20.0",
            "sellingModelType": null,
            "subType": null,
            "subscriptionTerm": null,
            "totalAdjustmentAmount": "0.00",
            "totalAmount": "20.00",
            "totalListPrice": "30.00",
            "totalPrice": "20.00",
            "totalTax": "0.00",
            "type": "Product",
            "unitAdjustedPrice": "20.0",
            "unitAdjustedPriceWithItemAdj": "20.0",
            "unitAdjustmentAmount": "0.0",
            "unitItemAdjustmentAmount": "0"
          },
          "message": null,
          "status": "Success"
        },
        {
          "cartItem": {
            "billingFrequency": null,
            "cartData": null,
            "cartDeliveryGroupId": "0a7xx00000000pdAAA",
            "cartId": "0a6xx00000000pdAAA",
            "cartItemId": "0a9xx00000000zKAAQ",
            "childProductCount": 0,
            "currencyIsoCode": "USD",
            "customFields": [],
            "firstPymtTotalAmount": "2.99",
            "firstPymtTotalListPrice": "3.99",
            "firstPymtTotalPrice": "2.99",
            "firstPymtTotalTax": "0.00",
            "isConfigurationAllowed": false,
            "isShippingChargeNotApplicable": false,
            "itemizedAdjustmentAmount": "0.00",
            "listPrice": "3.99",
            "messagesSummary": {
              "errorCount": null,
              "hasErrors": null,
              "limitedMessages": [],
              "relatedEntityId": null,
              "totalLineItemsWithErrors": null
            },
            "name": "Wired Mouse",
            "parentCartItemId": null,
            "productClass": "Simple",
            "productDetails": {
              "fields": {
                "LastModifiedDate": "2025-10-23T11:33:37Z",
                "FulfillmentQtyCalcMethod": null,
                "Description": "Wired mouse",
                "SpecificationType": "Commercial",
                "IsActive": "true",
                "LastReferencedDate": null,
                "StockKeepingUnit": "NHKWM",
                "Name": "Wired Mouse",
                "ShippingWeightUnitOfMeasure": null,
                "CreatedById": "005xx000001XBov",
                "CloneSourceId": null,
                "RecordTypeId": "012xx0000005qmC",
                "DiscontinuedDate": null,
                "ProductClass": "Simple",
                "CanRamp": "false",
                "DisplayUrl": null,
                "IsDeleted": "false",
                "IsAssetizable": "false",
                "ProductCode": null,
                "UsageModelType": null,
                "ExternalId": null,
                "ProductPurpose": "Sell",
                "LastViewedDate": null,
                "UserRecordAccessId": null,
                "HelpText": null,
                "CurrencyIsoCode": "USD",
                "AvailabilityDate": null,
                "SystemModstamp": "2025-10-23T11:33:37Z",
                "IsArchived": "false",
                "DecompositionScope": null,
                "Type": null,
                "EndOfLifeDate": null,
                "IsShippingChargeNotApplicable": "false",
                "QuantityUnitOfMeasure": null,
                "CreatedDate": "2025-10-23T11:33:37Z",
                "Family": null,
                "UnitOfMeasureId": null,
                "ShippingWeight": null,
                "LastModifiedById": "005xx000001XBov",
                "IsSoldOnlyWithOtherProds": "false"
              },
              "isConfigurationAllowed": null,
              "name": "Wired Mouse",
              "productClass": null,
              "productId": "01txx0000006kexAAA",
              "productSubscriptionInformation": null,
              "productUrlName": null,
              "purchaseQuantityRule": null,
              "sku": "NHKWM",
              "thumbnailImage": {
                "alternateText": "mouse.jpg",
                "contentVersionId": null,
                "id": "2pmxx000000000JAAQ",
                "mediaType": "Image",
                "sortOrder": 0,
                "thumbnailUrl": null,
                "title": "mouse.jpg",
                "url": "/cms/delivery/media/MCWAVWDLQILBFMFIG2LGAY5F3XYU?version=1.1&channelId=0apxx0000000003&oid=00Dxx00ThLVJ544"
              },
              "variationAttributes": {}
            },
            "productId": "01txx0000006kexAAA",
            "productSellingModelId": null,
            "promotionDisplayName": null,
            "quantity": "1.0",
            "salesPrice": "2.99",
            "sellingModelType": null,
            "subType": null,
            "subscriptionTerm": null,
            "totalAdjustmentAmount": "0.00",
            "totalAmount": "2.99",
            "totalListPrice": "3.99",
            "totalPrice": "2.99",
            "totalTax": "0.00",
            "type": "Product",
            "unitAdjustedPrice": "2.99",
            "unitAdjustedPriceWithItemAdj": "2.99",
            "unitAdjustmentAmount": "0.0",
            "unitItemAdjustmentAmount": "0"
          },
          "message": null,
          "status": "Success"
        }
      ],
      "count": 2,
      "currentPageToken": null,
      "currentPageUrl": null,
      "hasErrors": false,
      "nextPageToken": null,
      "nextPageUrl": null,
      "previousPageToken": "2025-10-23T13:49:07Z,0a9xx00000000zPAAQ,CreatedDateAsc",
      "previousPageUrl": "/services/data/v66.0/commerce/webstores/0ZExx00000000mP/carts/current/cart-items/0a9xx00000000zJ/children?page=2025-10-23T13%3A49%3A07Z%2C0a9xx00000000zPAAQ%2CCreatedDateAsc&pageSize=200&productFields=*&sort=CreatedDateAsc"
    }
    ```
    
*   **400** Bad Request
    
    Media type: `application/json`. Schema: `object`.
    
    *   `errorCode` (_string_)
    *   `message` (_string_)
    
    _Example: InvalidParameter_
    
    ```
    {
      "errorCode": "INVALID_OPERATION",
      "message": "Currency ISO code not available: '\"INR\"'."
    }
    ```
    
*   **404** Not Found
    
    Media type: `application/json`. Schema: `object`.
    
    *   `errorCode` (_string_)
    *   `message` (_string_)
    
    _Example_
    
    ```
    {
      "CartNotFound": {
        "value": {
          "errorCode": "CART_NOT_FOUND",
          "message": "Cart not found."
        }
      }
    }
    ```
    
*   **500** Internal Server Error - Unexpected system error occurred
    
    Media type: `application/json`. Schema: `object`.
    
    *   `errorCode` (_string_)
    *   `message` (_string_)
    
    _Example: InvalidParameter_
    
    ```
    {
      "errorCode": "UNKNOWN_EXCEPTION",
      "message": "Invalid parameter value."
    }
    ```
    

### POST Applies a saved configuration context to a cart item. This API adds, updates, or deletes the cart item based on product configuration retrieved using a specified context ID. This API is supported only for dynamic product bundles. Merchants must ensure that the Product Configurator setup is complete before using this API.

`POST /commerce/webstores/{webstoreId}/carts/{activeCartOrId}/cart-items/actions/apply-configuration`

Operation ID: `postCartItemsFromConfiguration`.

Applies a saved configuration context to a cart item.

#### Parameters

*   `activeCartOrId` (path, string, required) The valid value is—cartId (ID of the cart), active (this value is only to be used for authenticated users), or current (cart that isn’t closed or pending deletion). Use active only for B2B Aura stores; all other stores must use current.
*   `webstoreId` (path, string (Id), required) The ID of the web store.
*   `currencyIsoCode` (query, string) The three-letter ISO 4217 currency code of the cart.
*   `effectiveAccountId` (query, string (Id)) The ID of the buyer account or guest buyer profile for which the request is made. If unspecified, the default value is determined from context.

#### Request body

Media type: `application/json`. Schema: `sfdc.commerce.cart.connect.api.input.CartItemsConfigurationInputRepresentation`.

_Example: CartItemsConfigurationInput_ Applies the product configuration to the cart items.

```
{
  "contextId": "0000000c27nc17g001317606221363347ae616c7632d4266a1a108e90d10d983"
}
```

#### Responses

*   **200** Success
    
    Media type: `application/json`. Schema: `sfdc.commerce.cart.connect.api.output.CartItemsConfigurationOutputRepresentation`.
    
*   **400** Bad Request
    
    Media type: `application/json`. Schema: `object`.
    
    *   `message` (_string_)
    
    _Example: invalidContextId_ Invalid ContextId
    
    ```
    {
      "message": "Invalid context ID."
    }
    ```
    
    _Example: cartValidationFailed_ Cart validation failed
    
    ```
    {
      "message": "Cart validation failed."
    }
    ```
    
    _Example: productClassInvalid_ Product class is invalid
    
    ```
    {
      "message": "Invalid product class."
    }
    ```
    
    _Example: sellingModelInvalid_ Product selling model is invalid
    
    ```
    {
      "message": "Invalid product selling model."
    }
    ```
    
    _Example: maxCartLimitExceeded_ Max cart limit exceeded
    
    ```
    {
      "message": "Cart item limit exceeded."
    }
    ```
    
*   **401** UnAuthorized
    
    Media type: `application/json`. Schema: `object`.
    
    *   `message` (_string_)
    
    _Example_
    
    ```
    {
      "message": "Authentication failed."
    }
    ```
    
*   **403** Forbidden
    
    Media type: `application/json`. Schema: `array of object`.
    
    Array of `object`.
    
    *   `errorCode` (_string_)
    *   `message` (_string_)
    
    _Example: invalidOperation_ Invalid operation
    
    ```
    {
      "errorCode": "INVALID_OPERATION",
      "message": "The requested operation isn't allowed for this cart."
    }
    ```
    
    _Example: invalidInput_ Invalid input
    
    ```
    {
      "errorCode": "INVALID_INPUT",
      "message": "Invalid configuration parameters were provided."
    }
    ```
    
    _Example: insufficientAccess_ Insufficient access
    
    ```
    {
      "errorCode": "INSUFFICIENT_ACCESS_OR_READONLY",
      "message": "You don't have sufficient permissions to perform this operation."
    }
    ```
    
    _Example: cartInCheckoutState_ Cart in invalid state
    
    ```
    {
      "errorCode": "INVALID_OPERATION",
      "message": "The cart context can't be configured while the cart is in the checkout state."
    }
    ```
    
*   **404** Not Found
    
    Media type: `application/json`. Schema: `object`.
    
    *   `message` (_string_)
    
    _Example_
    
    ```
    {
      "message": "Cart not found."
    }
    ```
    
*   **409** Conflict
    
    Media type: `application/json`. Schema: `object`.
    
    *   `message` (_string_)
    
    _Example_
    
    ```
    {
      "message": "The request couldn’t be completed due to a conflict with the current cart state. Review your cart and try again."
    }
    ```
    
*   **412** Precondition Failed
    
    Media type: `application/json`. Schema: `array of object`.
    
    Array of `object`.
    
    *   `errorCode` (_string_)
    *   `message` (_string_)
    
    _Example: apexFailed_ Apex calculation failed
    
    ```
    {
      "errorCode": "APEX_FAILED",
      "message": "The cart summary calculation failed due to an internal Apex error."
    }
    ```
    
    _Example: ccaExecutionFailed_ CCA execution failed
    
    ```
    {
      "errorCode": "APEX_FAILED",
      "message": "Unable to calculate cart totals and promotions."
    }
    ```
    
*   **500** Internal Server Error
    
    Media type: `application/json`. Schema: `array of object`.
    
    Array of `object`.
    
    *   `errorCode` (_string_)
    *   `message` (_string_)
    
    _Example: unknownException_ Unknown exception
    
    ```
    {
      "errorCode": "UNKNOWN_EXCEPTION",
      "message": "An unexpected error occurred while processing the request."
    }
    ```
    
    _Example: systemError_ System error
    
    ```
    {
      "errorCode": "UNKNOWN_EXCEPTION",
      "message": "An internal system error occurred while configuring the cart context."
    }
    ```
    
    _Example: unhandledException_ Unhandled exception
    
    ```
    {
      "errorCode": "UNKNOWN_EXCEPTION",
      "message": "An error occurred while configuring the cart context."
    }
    ```
    
*   **503** Service Unavailable
    
    Media type: `application/json`. Schema: `array of object`.
    
    Array of `object`.
    
    *   `errorCode` (_string_)
    *   `message` (_string_)
    
    _Example: maintenanceMode_ System in maintenance mode
    
    ```
    {
      "errorCode": "INSERT_UPDATE_DELETE_NOT_ALLOWED_DURING_MAINTENANCE",
      "message": "The system is currently in maintenance mode and can't process requests. Try again later."
    }
    ```
    
    _Example: readOnlyMode_ System in read-only mode
    
    ```
    {
      "errorCode": "INSERT_UPDATE_DELETE_NOT_ALLOWED_DURING_MAINTENANCE",
      "message": "The system is currently in read-only mode and can't process updates. Try again later."
    }
    ```
    

### POST Distribute cart items into delivery groups.

`POST /commerce/webstores/{webstoreId}/carts/{activeCartOrId}/delivery-groups/actions/itemDistributions`

Operation ID: `postCartItemMove`.

Distribute cart items into delivery groups.

#### Parameters

*   `activeCartOrId` (path, string, required) The valid value is—cartId (ID of the cart), active (this value is only to be used for authenticated users), or current (cart that isn’t closed or pending deletion). Use active only for B2B Aura stores; all other stores must use current.
*   `webstoreId` (path, string (Id), required) The ID of the web store.

#### Request body

Media type: `application/json`. Schema: `sfdc.commerce.cart.connect.api.input.CartItemMoveCollectionInputRepresentation`.

#### Responses

*   **200** Success
    
    Media type: `application/json`. Schema: `sfdc.commerce.cart.connect.api.output.BatchResultRepresentation`.
    

### GET Retrieve promotions associated with a cart.

`GET /commerce/webstores/{webstoreId}/carts/{activeCartOrId}/promotions`

Operation ID: `getCartPromotionCollection`.

Used to get all promotions associated with the cart.

#### Parameters

*   `activeCartOrId` (path, string, required) The valid value is—cartId (ID of the cart), active (this value is only to be used for authenticated users), or current (cart that isn’t closed or pending deletion). Use active only for B2B Aura stores; all other stores must use current.
*   `webstoreId` (path, string (Id), required) The ID of the web store.
*   `currencyIsoCode` (query, string) The three-letter ISO 4217 currency code of the cart.
*   `effectiveAccountId` (query, string (Id)) The ID of the buyer account or guest buyer profile for which the request is made. If unspecified, the default value is determined from context.

#### Responses

*   **200** Success
    
    Media type: `application/json`. Schema: `sfdc.commerce.cart.connect.api.output.CartPromotionCollectionRepresentation`.
    

### POST Create a cart.

`POST /commerce/webstores/{webstoreId}/carts`

Operation ID: `postCartCollection`.

Gets a list of Carts or used for creating a cart.

Only buyers with read access to carts can create carts.

#### Parameters

*   `webstoreId` (path, string (Id), required) The ID of the web store.

#### Request body

Media type: `application/json`. Schema: `sfdc.commerce.cart.connect.api.input.CartInputRepresentation`.

_Example: CreateCartInput_ Example of the cart input to create a cart for the specified account using the provided currency, USD, in an org with the multicurrency feature enabled.

```
{
  "name": "MyCart",
  "type": "Cart",
  "currencyIsoCode": "USD",
  "effectiveAccountId": "001OL000002LC0qYAG"
}
```

_Example: CreateCartWithCustomFieldsInput_ Example of the cart input to create a cart with custom fields from the WebCart sObject. Custom fields are optional and must be previously defined for the sObject.

```
{
  "name": "MyCart",
  "type": "Cart",
  "currencyIsoCode": "USD",
  "effectiveAccountId": "001OL000002LC0qYAG",
  "customFields": {
    "attributes": {
      "type": "WebCart"
    },
    "MyCustomTextField__c": "Text",
    "MyCustomNumberField__c": 12.34,
    "MyCustomPercentField__c": 0.2345,
    "MyCustomGeolocationField__c": {
      "latitude": 33.345,
      "longitude": 45.567
    }
  }
}
```

#### Responses

*   **200** Success
    
    Media type: `application/json`. Schema: `sfdc.commerce.cart.connect.api.output.CartSummaryRepresentation`.
    
    _Example: Example_ Successfully created cart.
    
    ```
    {
      "accountId": "3K0SG000000OTaQ0AW",
      "asyncOperationStatus": null,
      "cartId": "0a6SG000001qGHpYAM",
      "currencyIsoCode": "USD",
      "customFields": [],
      "firstPymtGrandTotalAmount": 0,
      "firstPymtTotalAmount": 0,
      "firstPymtTotalListPrice": 0,
      "firstPymtTotalTaxAmount": 0,
      "grandTotalAmount": 0,
      "isSecondary": false,
      "messagesSummary": {
        "errorCount": null,
        "hasErrors": null,
        "limitedMessages": [],
        "relatedEntityId": null,
        "totalLineItemsWithErrors": null
      },
      "name": "My Cart",
      "orderOwnerId": null,
      "ownerId": "005SG00000Gjt8oYAB",
      "purchaseOrderNumber": null,
      "status": "Active",
      "taxType": "Automatic",
      "totalAmountWithItemAdjustment": 0,
      "totalCartLevelAdjustmentAmount": 0,
      "totalChargeAmount": 0,
      "totalChargeAmountWithItemAdjustment": 0,
      "totalListPrice": 0,
      "totalProductAmount": 0,
      "totalProductAmountAfterAdjustments": 0,
      "totalProductCount": 0,
      "totalProductLineItemCount": 0,
      "totalProductListAmount": 0,
      "totalPromotionalAdjustmentAmount": 0,
      "totalSubProductCount": 0,
      "totalTaxAmount": 0,
      "type": "Cart",
      "uniqueProductCount": 0,
      "webstoreId": "0ZESG000001n96S4AQ"
    }
    ```
    
*   **404** Client Error
    
    Media type: `application/json`. Schema: `sfdc.commerce.cart.connect.api.output.CartSummaryRepresentation`.
    
    _Example: Example_ Client error.
    
    ```
    [
      {
        "errorCode": "NOT_FOUND",
        "message": "The requested resource doesn't exist."
      }
    ]
    ```
    
*   **500** Internal Server Error
    
    Media type: `application/json`. Schema: `sfdc.commerce.cart.connect.api.output.CartSummaryRepresentation`.
    
    _Example: Example_ Internal server error.
    
    ```
    [
      {
        "errorCode": "UNKNOWN_EXCEPTION",
        "message": "Invalid parameter value \\\"3K0SG000000OT\\\" for parameter \\\"id\\\"."
      }
    ]
    ```
    

### DELETE Delete an item in a cart.

`DELETE /commerce/webstores/{webstoreId}/carts/{activeCartOrId}/cart-items/{cartItemId}`

Operation ID: `deleteCartItem`.

Used to update or delete single cart item.

Only buyers with read access to carts can delete items in carts.

#### Parameters

*   `activeCartOrId` (path, string, required) The valid value is—cartId (ID of the cart), active (this value is only to be used for authenticated users), or current (cart that isn’t closed or pending deletion). Use active only for B2B Aura stores; all other stores must use current.
*   `cartItemId` (path, string (Id), required) The ID of the cart item.
*   `webstoreId` (path, string (Id), required) The ID of the web store.
*   `effectiveAccountId` (query, string (Id)) The ID of the buyer account or guest buyer profile for which the request is made. If unspecified, the default value is determined from context.

#### Responses

*   **200** Success

### PATCH Update an item in a cart.

`PATCH /commerce/webstores/{webstoreId}/carts/{activeCartOrId}/cart-items/{cartItemId}`

Operation ID: `patchCartItem`.

Used to update or delete single cart item.

Buyers with read access to carts can update items in carts. Updating items in a cart respects buyer view product entitlements, and only users entitled to view product data can access it.

#### Parameters

*   `activeCartOrId` (path, string, required) The valid value is—cartId (ID of the cart), active (this value is only to be used for authenticated users), or current (cart that isn’t closed or pending deletion). Use active only for B2B Aura stores; all other stores must use current.
*   `cartItemId` (path, string (Id), required) The ID of the cart item.
*   `webstoreId` (path, string (Id), required) The ID of the web store.
*   `currencyIsoCode` (query, string) The three-letter ISO 4217 currency code of the cart.
*   `effectiveAccountId` (query, string (Id)) The ID of the buyer account or guest buyer profile for which the request is made. If unspecified, the default value is determined from context.
*   `includeCartData` (query, boolean) Specify to include complete cart data in the response. This is available ONLY when in sync mode.

#### Request body

Media type: `application/json`. Schema: `sfdc.commerce.cart.connect.api.input.CartItemInputRepresentation`.

_Example: UpdateCartItemsInput_ This cart input updates an item in a cart.

```
{
  "quantity": 7
}
```

#### Responses

*   **200** Success
    
    Media type: `application/json`. Schema: `sfdc.commerce.cart.connect.api.output.CartItemRepresentation`.
    
    _Example: Example_ Successfully updated cart.
    
    ```
    {
      "billingFrequency": null,
      "cartDeliveryGroupId": "0a7SG000001vIajYAE",
      "cartId": "0a6SG000001rCgnYAE",
      "cartItemId": "0a9SG000005Lm0LYAS",
      "childProductCount": 0,
      "currencyIsoCode": "USD",
      "customFields": [],
      "firstPymtTotalAmount": null,
      "firstPymtTotalListPrice": 49.98,
      "firstPymtTotalPrice": 41,
      "firstPymtTotalTax": null,
      "itemizedAdjustmentAmount": 0,
      "listPrice": 24.99,
      "messagesSummary": {
        "errorCount": null,
        "hasErrors": null,
        "limitedMessages": [],
        "relatedEntityId": null,
        "totalLineItemsWithErrors": null
      },
      "name": "Alpine Energy Drink Chai Post 0.5L PET - 6 pack",
      "parentCartItemId": null,
      "productClass": "Simple",
      "productDetails": {
        "fields": {},
        "name": "Alpine Energy Drink Chai Post 0.5L PET - 6 pack",
        "productId": "01tSG000003uisfYAA",
        "productSubscriptionInformation": null,
        "purchaseQuantityRule": null,
        "sku": 6010009,
        "thumbnailImage": {
          "alternateText": null,
          "contentVersionId": null,
          "id": "2pmSG000005k7q3YAA",
          "mediaType": "Image",
          "sortOrder": 0,
          "thumbnailUrl": null,
          "title": "/northerntrailoutfitters.com/nto-alpine-nutrition/default/images/large/6Pack-Chai-Post-Large.jpg",
          "url": "https://s3.amazonaws.com/northerntrailoutfitters.com/nto-alpine-nutrition/default/images/large/6Pack-Chai-Post-Large.jpg"
        },
        "variationAttributes": {}
      },
      "productId": "01tSG000003uisfYAA",
      "productSellingModelId": null,
      "quantity": 2,
      "salesPrice": 20.5,
      "sellingModelType": null,
      "subType": null,
      "subscriptionTerm": null,
      "totalAdjustmentAmount": 0,
      "totalAmount": null,
      "totalListPrice": 49.98,
      "totalPrice": 41,
      "totalTax": null,
      "type": "Product",
      "unitAdjustedPrice": 20.5,
      "unitAdjustedPriceWithItemAdj": 20.5,
      "unitAdjustmentAmount": 0,
      "unitItemAdjustmentAmount": 0
    }
    ```
    

### GET Retrieve details of a delivery group in the cart.

`GET /commerce/webstores/{webstoreId}/carts/{activeCartOrId}/delivery-groups/{deliveryGroupId}`

Operation ID: `getDeliveryGroup`.

Delivery group in the cart.

#### Parameters

*   `activeCartOrId` (path, string, required) The valid value is—cartId (ID of the cart), active (this value is only to be used for authenticated users), or current (cart that isn’t closed or pending deletion). Use active only for B2B Aura stores; all other stores must use current.
*   `deliveryGroupId` (path, string (Id), required) The ID of the delivery group.
*   `webstoreId` (path, string (Id), required) The ID of the web store.
*   `effectiveAccountId` (query, string (Id)) Optional. The ID of the buyer account or guest buyer profile for which the request is made. If unspecified, the default value is determined from context.
*   `page` (query, string) Optional. The page token to use to view a page of information. Page tokens are returned as part of the response, such as currentPageToken or nextPageToken. If you don’t specify a value, the first page is returned.
*   `pageSize` (query, integer) Optional. The number of items per page. Valid values are from 1 through 100. If you don’t specify a value, the default size is 25.
*   `sort` (query, sfdc.commerce.cart.connect.api.enums.ConnectCartItemSortOrderEnum)

#### Responses

*   **200** Success
    
    Media type: `application/json`. Schema: `sfdc.commerce.cart.connect.api.output.DeliveryGroupRepresentation`.
    

### DELETE Delete a delivery group in the cart.

`DELETE /commerce/webstores/{webstoreId}/carts/{activeCartOrId}/delivery-groups/{deliveryGroupId}`

Operation ID: `deleteDeliveryGroup`.

Delivery group in the cart.

#### Parameters

*   `activeCartOrId` (path, string, required) The valid value is—cartId (ID of the cart), active (this value is only to be used for authenticated users), or current (cart that isn’t closed or pending deletion). Use active only for B2B Aura stores; all other stores must use current.
*   `deliveryGroupId` (path, string (Id), required) The ID of the delivery group.
*   `webstoreId` (path, string (Id), required) The ID of the web store.
*   `deleteCartItems` (query, boolean) Optional. Indicates whether to delete cart items associated with the delivery group (True) or not (False)
*   `effectiveAccountId` (query, string (Id)) Optional. The ID of the account for which the request is made. If unspecified, defaults to the account ID for the context user.

#### Responses

*   **200** Success

### PATCH Update a delivery group in the cart.

`PATCH /commerce/webstores/{webstoreId}/carts/{activeCartOrId}/delivery-groups/{deliveryGroupId}`

Operation ID: `patchDeliveryGroup`.

Delivery group in the cart.

#### Parameters

*   `activeCartOrId` (path, string, required) The valid value is—cartId (ID of the cart), active (this value is only to be used for authenticated users), or current (cart that isn’t closed or pending deletion). Use active only for B2B Aura stores; all other stores must use current.
*   `deliveryGroupId` (path, string (Id), required) The ID of the delivery group.
*   `webstoreId` (path, string (Id), required) The ID of the web store.
*   `effectiveAccountId` (query, string (Id)) The ID of the buyer account or guest buyer profile for which the request is made. If unspecified, the default value is determined from context.

#### Request body

Media type: `application/json`. Schema: `sfdc.commerce.common.connect.api.input.DeliveryGroupV2InputRepresentation`.

#### Responses

*   **200** Success
    
    Media type: `application/json`. Schema: `sfdc.commerce.cart.connect.api.output.DeliveryGroupRepresentation`.
    

### POST Perform a complete cart calculation based on the cart status.

`POST /commerce/webstores/{webstoreId}/carts/{activeCartOrId}/actions/calculate`

Operation ID: `postCartCalculate`.

Calculates an existing cart.

Possible calculations include computing prices, evaluating promotions, checking the inventory, computing shipping costs, evaluating shipping promotions, applying post shipping adjustments, and computing taxes.

#### Parameters

*   `activeCartOrId` (path, string, required) The valid value is—cartId (ID of the cart), active (this value is only to be used for authenticated users), or current (cart that isn’t closed or pending deletion). Use active only for B2B Aura stores; all other stores must use current.
*   `webstoreId` (path, string (Id), required) The ID of the web store.
*   `effectiveAccountId` (query, string (Id)) Optional. The ID of the account for which the request is made. If unspecified, defaults to the account ID for the context user.

#### Request body

Media type: `application/json`. Schema: `sfdc.commerce.cart.connect.api.input.CartCalculateInputRepresentation`.

_Example: cartCalculateInput_ Here's an example of the cart calculation POST request.

```
{
  "customFields": [
    {
      "attributes": {
        "type": "WebCart"
      },
      "WebCartCustomField1__c": "Foo"
    },
    {
      "attributes": {
        "type": "CartItem"
      },
      "id": "0a9xx0000000002CI1",
      "CartItemCustomField1__c": "CI1_Field1Value",
      "CartItemCustomField2__c": "CI1_Field2Value"
    },
    {
      "attributes": {
        "type": "CartItem"
      },
      "id": "0a9xx0000000002CI2",
      "CartItemCustomField1__c": "CI2_Field1Value",
      "CartItemCustomField2__c": "CI2_Field2Value"
    },
    {
      "attributes": {
        "type": "CartDeliveryGroup"
      },
      "id": "0a7xx000000000CDG1",
      "CartDeliveryGroupCustomField1__c": "CDG1_Field1Value",
      "CartDeliveryGroupCustomField2__c": "CDG1_Field2Value"
    }
  ]
}
```

#### Responses

*   **200** Success
    
    Media type: `application/json`. Schema: `sfdc.commerce.cart.connect.api.output.CartSummaryResultRepresentation`.
    

### GET Retrieve summary for a cart.

`GET /commerce/webstores/{webstoreId}/carts/{activeCartOrId}`

Operation ID: `getCartSummary`.

Create Cart/ Get Cart Summary/ Delete Cart

During asynchronous cart processing, if enabled, GET response headers include Location and Retry-After. While the cart is processing, GET requests return a 202 status and may include stale, null, or 0 pricing data. When cart processing is complete, requests return a 200 status with up-to-date pricing data.

#### Parameters

*   `activeCartOrId` (path, string, required) The valid value is—cartId (ID of the cart), active (this value is only to be used for authenticated users), or current (cart that isn’t closed or pending deletion). Use active only for B2B Aura stores; all other stores must use current.
*   `webstoreId` (path, string (Id), required) The ID of the web store.
*   `currencyIsoCode` (query, string) The three-letter ISO 4217 currency code of the cart.
*   `effectiveAccountId` (query, string (Id)) The ID of the buyer account or guest buyer profile for which the request is made. If unspecified, the default value is determined from context.

#### Responses

*   **200** Success
    
    Media type: `application/json`. Schema: `sfdc.commerce.cart.connect.api.output.CartSummaryRepresentation`.
    

### PUT Create an active cart

`PUT /commerce/webstores/{webstoreId}/carts/{activeCartOrId}`

Operation ID: `putCartSummary`.

Create Cart/ Get Cart Summary/ Delete Cart

If one doesn’t exist. Buyers with read access to carts can create carts. The PUT request doesn’t require parameters nor a request body.

#### Parameters

*   `activeCartOrId` (path, string, required) The valid value is—cartId (ID of the cart), active (this value is only to be used for authenticated users), or current (cart that isn’t closed or pending deletion). Use active only for B2B Aura stores; all other stores must use current.
*   `webstoreId` (path, string (Id), required) The ID of the web store.
*   `currencyIsoCode` (query, string) The three-letter ISO 4217 currency code of the cart.
*   `effectiveAccountId` (query, string (Id)) The ID of the buyer account or guest buyer profile for which the request is made. If unspecified, the default value is determined from context.

#### Responses

*   **200** Success
    
    Media type: `application/json`. Schema: `sfdc.commerce.cart.connect.api.output.CartSummaryRepresentation`.
    

### DELETE Delete a cart.

`DELETE /commerce/webstores/{webstoreId}/carts/{activeCartOrId}`

Operation ID: `deleteCartSummary`.

Create Cart/ Get Cart Summary/ Delete Cart

Only buyers with read access to carts can delete carts.

#### Parameters

*   `activeCartOrId` (path, string, required) The valid value is—cartId (ID of the cart), active (this value is only to be used for authenticated users), or current (cart that isn’t closed or pending deletion). Use active only for B2B Aura stores; all other stores must use current.
*   `webstoreId` (path, string (Id), required) The ID of the web store.
*   `effectiveAccountId` (query, string (Id)) The ID of the buyer account or guest buyer profile for which the request is made. If unspecified, the default value is determined from context.

#### Responses

*   **200** Success

### PATCH patchCartSummary

`PATCH /commerce/webstores/{webstoreId}/carts/{activeCartOrId}`

Operation ID: `patchCartSummary`.

Create Cart/ Get Cart Summary/ Delete Cart

Update name and description for the cart.

#### Parameters

*   `activeCartOrId` (path, string, required) The valid value is—cartId (ID of the cart), active (this value is only to be used for authenticated users), or current (cart that isn’t closed or pending deletion). Use active only for B2B Aura stores; all other stores must use current.
*   `webstoreId` (path, string (Id), required) The ID of the web store.
*   `effectiveAccountId` (query, string (Id), required) The ID of the buyer account or guest buyer profile for which the request is made. If unspecified, the default value is determined from context.

#### Request body

Media type: `application/json`. Schema: `object`.

*   `name` (_string_, required) The name of the cart. The name can have up to 250 Unicode characters. Avoid using special characters in the cart name, including `\"'<>@!$#&%\\{[]}`.
*   `description` (_string_) The description for the cart.

#### Responses

*   **200** Success
    
    Media type: `application/json`. Schema: `sfdc.commerce.cart.connect.api.output.CartSummaryRepresentation`.
    
*   **400** Bad Request - Invalid input parameters or request data.
    
    Media type: `application/json`. Schema: `sfdc.commerce.cart.connect.api.output.ErrorOutputRepresentation`.
    
    _Example: InvalidEffectiveAccountId_
    
    ```
    {
      "errors": [
        {
          "code": "INVALID_API_INPUT",
          "message": "The provided EffectiveAccountId parameter is invalid or malformed."
        }
      ]
    }
    ```
    
*   **404** Not Found - Requested resource doesn't exist.
    
    Media type: `application/json`. Schema: `sfdc.commerce.cart.connect.api.output.ErrorOutputRepresentation`.
    
    _Example: WebstoreNotFound_
    
    ```
    {
      "errors": [
        {
          "code": "WEBSTORE_NOT_FOUND",
          "message": "The specified webstore doesn't exist or isn't accessible."
        }
      ]
    }
    ```
    
*   **500** Internal Server Error - Unexpected system error occurred.
    
    Media type: `application/json`. Schema: `sfdc.commerce.cart.connect.api.output.ErrorOutputRepresentation`.
    
    _Example: InternalServerError_
    
    ```
    {
      "errors": [
        {
          "code": "INTERNAL_SERVER_ERROR",
          "message": "An unexpected error occurred while processing the request."
        }
      ]
    }
    ```
    

### GET Retrieve compact cart summary for an existing cart.

`GET /commerce/webstores/{webstoreId}/carts/compact-summary`

Operation ID: `getCartBadge`.

The compact cart summary for an existing cart.

#### Parameters

*   `currencyIsoCode` (query, string) The three-letter ISO 4217 currency code of the cart.
*   `effectiveAccountId` (query, string (Id)) The ID of the buyer account or guest buyer profile for which the request is made. If unspecified, the default value is determined from context.

#### Responses

*   **200** Success
    
    Media type: `application/json`. Schema: `sfdc.commerce.cart.connect.api.output.CartSummaryCompactRepresentation`.
    
*   **400** Webstore not found
    
    Media type: `application/json`.
    
    _Example_
    
    ```
    [
      {
        "errorCode": "INVALID_INPUT",
        "message": "Invalid webstoreId"
      }
    ]
    ```
    

### POST Retrieve all promotions associated with the cart items.

`POST /commerce/webstores/{webstoreId}/carts/{activeCartOrId}/cart-items/promotions`

Operation ID: `postCartItemPromotionCollection`.

Retrieve all promotions associated with the cart items.

POST methods typically create an item, but for this resource POST is used to retrieve information. Both POST and GET retrieve the same information. However, GET calls can be cached.

#### Parameters

*   `activeCartOrId` (path, string, required) The valid value is—cartId (ID of the cart), active (this value is only to be used for authenticated users), or current (cart that isn’t closed or pending deletion). Use active only for B2B Aura stores; all other stores must use current.
*   `webstoreId` (path, string (Id), required) The ID of the web store.
*   `currencyIsoCode` (query, string) The three-letter ISO 4217 currency code of the cart.
*   `effectiveAccountId` (query, string (Id)) The ID of the buyer account or guest buyer profile for which the request is made. If unspecified, the default value is determined from context.

#### Request body

Media type: `application/json`. Schema: `sfdc.commerce.cart.connect.api.input.CartItemPromotionCollectionInputRepresentation`.

_Example: Example_ Example of the cart item promotion collection input.

```
{
  "items": [
    {
      "cartItemId": "0a9xx000000000GAAQ"
    },
    {
      "cartItemId": "0a9xx000000000GBCQ"
    }
  ]
}
```

#### Responses

*   **200** Success
    
    Media type: `application/json`. Schema: `sfdc.commerce.cart.connect.api.output.CartItemPromotionCollectionOutputRepresentation`.
    

### POST Preserve cart contents when a guest logs in as an authenticated customer.

`POST /commerce/webstores/{webstoreId}/carts/{activeCartOrId}/actions/preserve`

Operation ID: `postPreserveCart`.

Allows preserving the guest cart.

When a guest user adds products to a cart and then logs in, the API creates a new authorized cart and transfers the guest cart’s items and applied coupons to it. The API doesn’t transfer delivery details, tax calculations, or custom fields. It deletes the guest cart after a successful transfer.

If the customer already has an existing cart from a prior authenticated session, the API sets the newly authorized cart as the primary cart and retains the previous cart as a secondary cart.

#### Parameters

*   `activeCartOrId` (path, string, required) The valid value is—cartId (ID of the cart), active (this value is only to be used for authenticated users), or current (cart that isn’t closed or pending deletion). Use active only for B2B Aura stores; all other stores must use current.
*   `webstoreId` (path, string (Id), required) The ID of the web store.
*   `currencyIsoCode` (query, string) The three-letter ISO 4217 currency code of the cart.
*   `effectiveAccountId` (query, string (Id)) The ID of the buyer account or guest buyer profile for which the request is made. If unspecified, the default value is determined from context.

#### Responses

*   **200** Success
    
    Media type: `application/json`. Schema: `sfdc.commerce.cart.connect.api.output.PreserveCartOutputRepresentation`.
    

### POST Arrange cart items into delivery groups.

`POST /commerce/webstores/{webstoreId}/carts/{activeCartOrId}/delivery-groups/actions/arrange-items`

Operation ID: `postCartItemArrange`.

Arrange cart items among delivery groups

#### Parameters

*   `activeCartOrId` (path, string, required) The valid value is—cartId (ID of the cart), active (this value is only to be used for authenticated users), or current (cart that isn’t closed or pending deletion). Use active only for B2B Aura stores; all other stores must use current.
*   `webstoreId` (path, string (Id), required) The ID of the web store.
*   `deleteEmptyDeliveryGroups` (query, boolean) Specifies whether to delete delivery groups with no cart items (true) or not (false). If unspecified, the default value is true.

#### Request body

Media type: `application/json`. Schema: `sfdc.commerce.cart.connect.api.input.ItemArrangementsInputRepresentation`.

_Example: Example_ Delivery group collection.

```
{
  "arrangements": [
    {
      "deliveryGroupId": "0a7xx000000004rAAA",
      "cartItemId": "0a9xx000000004rAAA",
      "quantity": 5
    }
  ]
}
```

#### Responses

*   **200** Success
    
    Media type: `application/json`. Schema: `sfdc.commerce.cart.connect.api.output.DeliveryGroupCollectionRepresentation`.
    

### GET Retrieve coupons associated with a cart.

`GET /commerce/webstores/{webstoreId}/carts/{activeCartOrId}/cart-coupons`

Operation ID: `getCartCouponCollection`.

Apply a coupon code to a cart.

#### Parameters

*   `activeCartOrId` (path, string, required) The valid value is—cartId (ID of the cart), active (this value is only to be used for authenticated users), or current (cart that isn’t closed or pending deletion). Use active only for B2B Aura stores; all other stores must use current.
*   `webstoreId` (path, string (Id), required) The ID of the web store.
*   `currencyIsoCode` (query, string) The three-letter ISO 4217 currency code of the cart.
*   `effectiveAccountId` (query, string (Id)) The ID of the buyer account or guest buyer profile for which the request is made. If unspecified, the default value is determined from context.

#### Responses

*   **200** Success
    
    Media type: `application/json`. Schema: `sfdc.commerce.cart.connect.api.output.CartCouponCollectionRepresentation`.
    

### POST Apply a coupon code to a cart.

`POST /commerce/webstores/{webstoreId}/carts/{activeCartOrId}/cart-coupons`

Operation ID: `postCartCouponCollection`.

Apply a coupon code to a cart.

In API version 63.0 and later, if your store has simplified cart cleanup enabled, a POST request can apply a coupon to a cart without canceling checkout.

#### Parameters

*   `activeCartOrId` (path, string, required) The valid value is—cartId (ID of the cart), active (this value is only to be used for authenticated users), or current (cart that isn’t closed or pending deletion). Use active only for B2B Aura stores; all other stores must use current.
*   `webstoreId` (path, string (Id), required) The ID of the web store.
*   `currencyIsoCode` (query, string) The three-letter ISO 4217 currency code of the cart.
*   `effectiveAccountId` (query, string (Id)) The ID of the buyer account or guest buyer profile for which the request is made. If unspecified, the default value is determined from context.

#### Request body

Media type: `application/json`. Schema: `sfdc.commerce.cart.connect.api.input.CartCouponInputRepresentation`.

_Example: Example_ Apply coupon.

```
{
  "couponCode": "COUP10",
  "customFields": [
    {
      "attributes": {
        "type": "WebCartAdjustmentBasis"
      },
      "Test__C": "test@salesforce.com"
    }
  ]
}
```

#### Responses

*   **200** Success
    
    Media type: `application/json`. Schema: `sfdc.commerce.cart.connect.api.output.CartCouponCollectionRepresentation`.
    

### GET Retrieve a collection of delivery groups in a cart.

`GET /commerce/webstores/{webstoreId}/carts/{activeCartOrId}/delivery-groups`

Operation ID: `getDeliveryGroupCollection`.

Create a collection of delivery groups in a cart.

Use CartItemLimit query param to limit the number of cart items included in each delivery group

#### Parameters

*   `activeCartOrId` (path, string, required) The valid value is—cartId (ID of the cart), active (this value is only to be used for authenticated users), or current (cart that isn’t closed or pending deletion). Use active only for B2B Aura stores; all other stores must use current.
*   `webstoreId` (path, string (Id), required) The ID of the web store.
*   `cartItemLimit` (query, integer) The limit of items in a cart.
*   `effectiveAccountId` (query, string (Id)) The ID of the account for which the request is made. If unspecified, defaults to the account ID for the context user.
*   `page` (query, string) Specifies the page token to use to view a page of information. Page tokens are returned as part of the response, such as currentPageToken or nextPageToken. If you don’t specify a value, the first page is returned.
*   `pageSize` (query, integer) Specifies the number of items per page. Valid values are from 1 through 100. If you don’t specify a value, the default size is 25.
*   `sort` (query, sfdc.commerce.cart.connect.api.enums.ConnectCartItemSortOrderEnum)

#### Responses

*   **200** Success
    
    Media type: `application/json`. Schema: `sfdc.commerce.cart.connect.api.output.DeliveryGroupCollectionRepresentation`.
    

### POST Create a collection of delivery groups in a cart.

`POST /commerce/webstores/{webstoreId}/carts/{activeCartOrId}/delivery-groups`

Operation ID: `postDeliveryGroupCollection`.

Create a collection of delivery groups in a cart.

#### Parameters

*   `activeCartOrId` (path, string, required) The valid value is—cartId (ID of the cart), active (this value is only to be used for authenticated users), or current (cart that isn’t closed or pending deletion). Use active only for B2B Aura stores; all other stores must use current.
*   `webstoreId` (path, string (Id), required) The ID of the web store.
*   `effectiveAccountId` (query, string (Id)) The ID of the account for which the request is made. If unspecified, defaults to the account ID for the context user.

#### Request body

Media type: `application/json`. Schema: `sfdc.commerce.common.connect.api.input.DeliveryGroupV2InputRepresentation`.

#### Responses

*   **200** Success
    
    Media type: `application/json`. Schema: `sfdc.commerce.cart.connect.api.output.DeliveryGroupRepresentation`.
    

### POST Create a new quote from an active cart by converting cart items into quote line items.

`POST /commerce/webstores/{webstoreId}/carts/{activeCartOrId}/quotes`

Operation ID: `postQuoteFromCart`.

This API is used on the Cart page of the B2B storefront to create a quote from the active cart, retaining pricing and customer details. Buyers can also specify an expiration date and add comments for negotiation.

To access these resources, your org must have the B2B Commerce license. This API is available only to authenticated users.

**Note:** The Commerce Quotes APIs don't support product bundles. Only simple products can be included in quote.

To access this API, your org must have the B2B Commerce license. This API is available only to authenticated users.

This API is used on the Cart page of the B2B storefront to create a quote from the active cart, retaining pricing and customer details. Buyers can also specify an expiration date and add comments for negotiation.

**Note:** Carts must contain at least one product to create a quote. Empty carts return an error. Promotions and bonus products aren't supported.

Supported product types by license:

*   Simple products: Supported with B2B Commerce Only or B2B Commerce and Revenue Cloud licenses.
*   Static bundles: Supported only with the B2B Commerce and Revenue Cloud licenses.
*   Dynamic bundles: Supported only with the B2B Commerce and Revenue Cloud licenses.
*   Subscription products: Not supported with either B2B Commerce Only or B2B Commerce and Revenue Cloud licenses.

#### Parameters

*   `webstoreId` (path, string (Id), required) The ID of the web store.
*   `activeCartOrId` (path, string (Id), required) The valid value is the cart ID of an active cart only.

#### Request body (required)

Media type: `application/json`. Schema: `sfdc.commerce.cart.connect.api.input.CreateQuoteFromCartInputRepresentation`.

_Example_

```
{
  "comments": "Provide bulk pricing for orders of 100+ units. We are interested in a long-term partnership.",
  "additionalFields": {
    "ExpirationDate": "2025-12-31",
    "BuyerEmail__c": "procurement@company.com"
  },
  "deleteCart": false
}
```

#### Responses

*   **200** Success — Quote created from cart.
    
    Media type: `application/json`. Schema: `sfdc.commerce.cart.connect.api.output.CreateQuoteFromCartOutputRepresentation`.
    
    _Example: Success_
    
    ```
    {
      "quoteId": "0Q0xx0000000001EAA",
      "errors": []
    }
    ```
    
*   **400** Bad Request - Invalid input parameters or request data.
    
    Media type: `application/json`. Schema: `sfdc.commerce.cart.connect.api.output.CreateQuoteFromCartOutputRepresentation`.
    
    _Example: InvalidCart_
    
    ```
    {
      "errors": [
        {
          "code": "INVALID_INPUT",
          "message": "The specified context ID is invalid."
        }
      ]
    }
    ```
    
    _Example: InvalidCustomFields_
    
    ```
    {
      "errors": [
        {
          "code": "INVALID_CUSTOM_FIELDS",
          "message": "One or more custom field values are invalid or don't meet required criteria."
        }
      ]
    }
    ```
    
    _Example: BundlesNotSupported_
    
    ```
    {
      "errors": [
        {
          "code": "BUNDLES_NOT_SUPPORTED",
          "message": "This request doesn't support product bundles."
        }
      ]
    }
    ```
    
*   **404** Not Found - Requested resource doesn't exist.
    
    Media type: `application/json`. Schema: `sfdc.commerce.cart.connect.api.output.CreateQuoteFromCartOutputRepresentation`.
    
    _Example: CartNotFound_
    
    ```
    {
      "errors": [
        {
          "code": "CART_NOT_FOUND",
          "message": "The specified cart doesn't exist or you don't have access to it."
        }
      ]
    }
    ```
    
    _Example: WebstoreNotFound_
    
    ```
    {
      "errors": [
        {
          "code": "WEBSTORE_NOT_FOUND",
          "message": "he specified web store doesn't exist or you do not have access to it."
        }
      ]
    }
    ```
    
*   **500** Internal Server Error - Unexpected system error occurred.
    
    Media type: `application/json`. Schema: `sfdc.commerce.cart.connect.api.output.CreateQuoteFromCartOutputRepresentation`.
    
    _Example: InternalServerError_
    
    ```
    {
      "errors": [
        {
          "code": "INTERNAL_SERVER_ERROR",
          "message": "An unexpected error occurred while processing the request."
        }
      ]
    }
    ```
    

### POST Create a cart from an approved quote, or duplicate a draft quote into a cart by converting the quote into cart items.

`POST /commerce/webstores/{webstoreId}/quotes/{quoteId}/cart`

Operation ID: `postCartFromQuote`.

This API performs one of the following operations based on the quote status:

*   Create Cart from Quote:
    *   Create a cart from a quote only when its status is Approved or Accepted, as initiated by the Accept & Buy action on the My Quotes page of the B2B storefront.
    *   All items are added at the negotiated and discounted prices.
    *   A quote can be converted to a cart only once if the resulting cart is used to place an order. After the order is placed, the same quote can't be reused.
    *   If the cart is cleared after conversion (before placing an order), the quote can be converted to a cart again.
*   Duplicate Quote to Cart:
    *   Duplicate the quote to cart, as initiated by the Duplicate to Cart action on the My Quotes page of the B2B storefront. This operation isn't supported only for quotes in Approved or Accepted status.
    *   All items are added at their original prices.

Duplicate-to-cart and convert-to-cart operations succeed only when the cart has no matching products. For example, if both the quote and the cart contain Product A, the API returns an error. Partial conversion or duplication, promotions, and bonus products aren't supported.

Supported product types by license:

*   Simple products: Supported with B2B Commerce only or B2B Commerce and Revenue Cloud licenses.
*   Static bundles: Supported with B2B Commerce only or B2B Commerce and Revenue Cloud licenses.
*   Dynamic bundles: Supported only with the B2B Commerce and Revenue Cloud license.
*   Subscription products: Not supported with either B2B Commerce Only or B2B Commerce and Revenue Cloud licenses.

#### Parameters

*   `webstoreId` (path, string (Id), required) The ID of the web store.
*   `quoteId` (path, string (Id), required) The ID of the quote record to convert to a cart.

#### Request body (required)

Media type: `application/json`. Schema: `sfdc.commerce.cart.connect.api.input.CreateCartFromQuoteInputRepresentation`.

_Example_

```
{
  "operationType": "CONVERT_TO_CART"
}
```

#### Responses

*   **200** Success — Cart created from quote.
    
    Media type: `application/json`. Schema: `sfdc.commerce.cart.connect.api.output.CartFromQuoteOutputRepresentation`.
    
    _Example: Success_
    
    ```
    {
      "cartId": "0Q0xx0000000001EAA",
      "errors": []
    }
    ```
    
*   **400** Bad Request - Invalid input parameters or request data.
    
    Media type: `application/json`. Schema: `sfdc.commerce.cart.connect.api.output.CartFromQuoteOutputRepresentation`.
    
    _Example: InvalidOperationType_
    
    ```
    {
      "errors": [
        {
          "code": "INVALID_OPERATION_TYPE",
          "message": "The provided operationType isn't supported."
        }
      ]
    }
    ```
    
*   **404** Not Found - Requested resource doesn't exist.
    
    Media type: `application/json`. Schema: `sfdc.commerce.cart.connect.api.output.CartFromQuoteOutputRepresentation`.
    
    _Example: QuoteNotFound_
    
    ```
    {
      "errors": [
        {
          "code": "QUOTE_NOT_FOUND",
          "message": "The specified quote doesn't exist or isn't accessible."
        }
      ]
    }
    ```
    
    _Example: WebstoreNotFound_
    
    ```
    {
      "errors": [
        {
          "code": "WEBSTORE_NOT_FOUND",
          "message": "The specified webstore doesn't exist or isn't accessible."
        }
      ]
    }
    ```
    
*   **500** Internal Server Error - Unexpected system error occurred.
    
    Media type: `application/json`. Schema: `sfdc.commerce.cart.connect.api.output.CartFromQuoteOutputRepresentation`.
    
    _Example: ProcessingError_
    
    ```
    {
      "errors": [
        {
          "code": "INTERNAL_SERVER_ERROR",
          "message": "An unexpected error occurred while creating the cart from the quote."
        }
      ]
    }
    ```
    

## Schemas

### sfdc.commerce.cart.connect.api.input.CartMessagesVisibilityInputRepresentation

Input for updating a message visibility status.

*   `visibility` (_boolean_) Indicates whether to set cart messages as visible (true) or not (false).

### sfdc.commerce.cart.connect.api.output.CartMessagesVisibilityResultRepresentation

Represents the updated visibility value for the cart messages.

*   `visibility` (_boolean_) Indicates whether cart messages are set to visible (true) or not (false).

### sfdc.commerce.cart.connect.api.input.CartItemInputRepresentation

Details of a cart item input.

*   `cartDeliveryGroupId` (_string_) The ID of the cart delivery group associated with the cart item.
*   `customFields` (_array of object_) An array of sObjects and custom fields for the sObjects. Standard fields are ignored. The custom fields must already be defined for the sObject. Currently, only the CartItem sObject is supported. Field-level security rules from the shopper profile are applied to the custom fields. The rules are applied for registered shoppers and for the guest shopper profile. The custom fields can be of type Checkbox, Currency, Date, Email, LongTextArea, Number, Percent, Phone, Text, TextArea, Url, Address, or Location. The customFields property isn't supported in stores built on an Aura template.
    
    Additional properties: `any`.
    
*   `productId` (_string_) The ID of the product.
*   `productSellingModelId` (_string_) The ID of the product selling model associated with Product2.
*   `quantity` (_string_) The quantity of the cart item. Use a value that can be converted to BigDecimal.
*   `subscriptionTerm` (_integer_) The total number of terms in the subscription period.
*   `type` (_any_) The type of item in a cart. This field isn't supported for the PATCH method.

### core.connect.api.output.common.BatchRepresentation

Result of an entire batch request operation. Results are ordered in the same order in which the requests were given. Results are either a successful result with a response body, a successful result without a response body, or an error result without a response body. Success and error are determined by the status code in each result.

*   `hasErrors` (_boolean_) Indicates whether at least one of the results is an error status code in the 400 or 500 range (true) or not (false).
*   `results` (_array of sfdc.commerce.cart.connect.api.output.BatchResultRepresentation_) The collection of batch result items.

### sfdc.commerce.cart.connect.api.input.CartEvaluateShippingInputRepresentation

Details of the cart calculate evaluate shipping input request.

*   `customFields` (_array of object_) Array of sObjects and custom fields for the sObjects. Standard fields are ignored. The custom fields must already be defined for the sObject. Currently, the WebCart, CartItem, and CartDeliveryGroup sObjects are supported. Field-level security rules from the shopper profile are applied to the custom fields. The rules are applied for registered shoppers and for the guest shopper profile.
    
    Additional properties: `any`.
    
*   `shippingAddress` (_sfdc.commerce.common.connect.api.input.CartShippingAddressInputRepresentation_)

### sfdc.commerce.cart.connect.api.output.CartSummaryResultRepresentation

Result of calculating a cart.

Includes all fields of `sfdc.commerce.cart.connect.api.output.CommerceResultRepresentationBase`.

*   `data` (_sfdc.commerce.cart.connect.api.output.CartSummaryRepresentation_)

### sfdc.commerce.cart.connect.api.output.ProductCartItemRepresentation

Cart items of a specific product type.

*   `cartItems` (_array of sfdc.commerce.cart.connect.api.output.CartItemResultRepresentation_) The collection of items in a cart.
*   `product` (_sfdc.commerce.cart.connect.api.output.CartProductSummaryRepresentation_)

### sfdc.commerce.cart.connect.api.input.CartInventoryReservationInputRepresentation

Details of the create a reservation input request.

*   `durationInSeconds` (_integer_, required) Reservation duration in seconds.

### sfdc.commerce.cart.connect.api.output.CartInventoryReservationOutputRepresentation

An inventory reservation.

*   `errorCode` (_string_) The error code for this reservation.
*   `errorMessage` (_string_) The error message for this reservation.
*   `inventoryItemReservations` (_array of sfdc.commerce.cart.connect.api.output.CartInventoryItemReservationOutputRepresentation_) The collection of inventory item reservations.
*   `reservationIdentifier` (_string_) The reservation identifier.
*   `success` (_boolean_) Indicates whether the transaction was successful (true) or not (false).

### sfdc.commerce.cart.connect.api.output.ProductCartItemCollectionRepresentation

Items in the cart, grouped by product type.

*   `count` (_integer_) The number of cart items returned on the current page.
*   `currentPage` (_integer_) The current page of cart items. The value matches the requested page number, unless the requested page number exceeds the total number of pages. In this scenario, the current page is the highest available page number.
*   `hasErrors` (_boolean_) Indicates whether at least one of the results contains an error (True) or not (False).
*   `products` (_array of sfdc.commerce.cart.connect.api.output.ProductCartItemRepresentation_) The collection of products in the cart.
*   `totalItemCount` (_integer_) The total number of unique products in the cart.
*   `totalNumberOfPages` (_integer_) The total number of pages for the given page size.

### sfdc.commerce.cart.connect.api.input.CartToWishlistInputRepresentation

Details of products to be copied from a cart to a wishlist.

*   `wishlistId` (_string_) The ID of the wishlist to copy cart products to.

### sfdc.commerce.cart.connect.api.output.CartToWishlistResultRepresentation

Result of copying products from a cart to a wishlist.

*   `productsAddedCount` (_integer_) The number of products copied from the cart to the wishlist.
*   `wishlistId` (_string (Id)_) The ID of the wishlist that cart products were copied to.

### sfdc.commerce.cart.connect.api.output.CartSummaryRepresentation

Summary of information about a cart and its contents.

*   `accountId` (_string (Id)_) The ID of account for the cart.
*   `asyncOperationStatus` (_sfdc.commerce.cart.connect.api.enums.ConnectCartAsyncOperationStatusEnum_)
*   `cartId` (_string (Id)_) The ID of the cart.
*   `currencyIsoCode` (_string_) The three-letter ISO 4217 currency code associated with the cart.
*   `customFields` (_array of object_) Array of sObjects and viewable custom fields for the sObjects. Field-level security rules from the shopper profile are applied to the custom fields. The rules are applied for registered shoppers and for the guest shopper profile. If no custom fields were specified, returns an empty collection.
    
    Additional properties: `any`.
    
*   `firstPymtGrandTotalAmount` (_string_) First payment amount for subscription products, plus the total payment amount for non-subscription products, including taxes.
*   `firstPymtTotalAmount` (_string_) The total amount on the first payment of the cart.
*   `firstPymtTotalListPrice` (_string_) The total list price on the first payment of the cart.
*   `firstPymtTotalTaxAmount` (_string_) Tax amount on the first payment for any subscription products, plus the total tax amount on non-subscription products.
*   `grandTotalAmount` (_string_) Grand total amount including shipping and tax for items in the cart, in the currency of the cart. and tax).
*   `isSecondary` (_boolean_) Indicates whether the cart is secondary (true) or not (false).
*   `messagesSummary` (_sfdc.commerce.cart.connect.api.output.CartMessagesSummaryRepresentation_)
*   `name` (_string_) The name for the cart. The name can have up to 250 Unicode characters. Avoid using special characters in the cart name, including `\"'<>@!$#&%\\{[]}`. If unspecified, a cart name is generated automatically using the pattern, `Untitled Cart - [Date] [Time]`.
*   `description` (_string_) The description for the cart.
*   `orderOwnerId` (_string (Id)_) The ID of the owner of the cart.
*   `ownerId` (_string (Id)_) The ID of the owner of the order.
*   `purchaseOrderNumber` (_string_) The purchase order for the cart.
*   `status` (_sfdc.commerce.cart.connect.api.enums.ConnectCartStatusEnum_)
*   `taxType` (_sfdc.commerce.cart.connect.api.enums.ConnectCartTaxTypeEnum_)
*   `totalAmountWithItemAdjustment` (_string_) The total amount, including both tier and item level discounts but excluding cart level discounts, for all items in the cart.
*   `totalCartLevelAdjustmentAmount` (_string_) The total cart level discount amount for the cart.
*   `totalChargeAmount` (_string_) The total amount for shipping and other charges in the currency of the cart. Includes adjustments from shipping promotions.
*   `totalChargeAmountWithItemAdjustment` (_string_) The total amount with shipping item level adjustment on cart.
*   `totalListPrice` (_string_) The total list price for the cart.
*   `totalProductAmount` (_string_) The total including discounts, but excluding shipping and tax, for product items in the cart.
*   `totalProductAmountAfterAdjustments` (_string_) The total product amount when promotion is turned off and sum of total product amount and total promotional adjustment amount with promotions turned on.
*   `totalProductCount` (_string_) The total count of items in the cart. This field may not be accurate when faster add-to-cart is turned on and quantity rules are enabled for products in the cart.
*   `totalProductLineItemCount` (_integer_) The total count of line items, of the type Product, in the cart. cart.
[...]
